/*global require*/
'use strict';

// Require.js allows us to configure shortcut alias
require.config({

	waitSeconds: 200,
	// The shim config allows us to configure dependencies for
	// scripts that do not call define() to register a module
	shim: {
		underscore: {
			exports: '_'
		},
		backbone: {
			deps: [
			'underscore',
			'af'
			],
			exports: 'Backbone'
		},

		handlebars:{
			exports:'Handlebars'
		},
		af: {
			exports: '$'
		},
		ui:{
			exports: 'ui'
		},
		carousel: {
			deps:[
				'af'
			]
		},
		css3animate: {
			deps:[
				'af'
			]
		}

	},
	paths: {
		af: 'libs/appFramework/appframework',
		ui: 'libs/appFramework/appframework.ui',

		underscore: 'libs/underscore',
		backbone: 'libs/backbone',
		handlebars:'libs/handlebars',
		text: 'libs/text',
		async: 'libs/async',
		utilmap: 'libs/util.map',
		fastclick : 'libs/fastclick',

		carousel: 'plugins/jq.carousel',
		css3animate: 'plugins/af.css3animate',

		pushNotifications: 'plugins/PushNotification'

		// googlemaps: 'async!http://maps.google.com/maps/api/js?sensor=true'
	}
});

// Includes File Dependencies
define(function (require) {

  var $ = require('af'),
      ui = require('ui'),
      Backbone = require('backbone'),
      Router = require('router');

  $.ui.autoLaunch = false;
  $.ui.openLinksNewTab = false;
  $.ui.loadHash = true;
  $.ui.manageHistory = false;
  

  $(document).ready(function(){
    $.ui.launch();
    $.ui.blockPageScroll(); //block the page from scrolling at the header/footer
		setTimeout(function(){
			new Router();
		},400);
  });
});