define(function (require) {
	/*Define require deps*/
  var $ = require('af'),
			ui = require('ui'),
			Config = require('config'),
      Backbone = require('backbone'),
      Handlebars = require('handlebars'),
      FastClick = require('fastclick'),

      TutorialView = require('views/tutorial'),
      HomeView = require('views/home'),
      RecentView = require('views/recent'),
      ServicesView = require('views/services'),
      ServicesGroupView = require('views/servicesGroup'),
      ServiceDetailView = require('views/serviceDetail'),
      CategoryView = require('views/category'),
      FavoritesView = require('views/favorites'),
      DeailView = require('views/deal'),
      HowView = require('views/how'),
      SearchView = require('views/search'),
      ContactView = require('views/contact'),
      PushListView = require('views/pushList'),

      Util = require('util'),

      BasicPair = require('pairs/basicPair'),
      FavsPair = require('pairs/favsPair'),
      currentPage = "",
      FavsServPair = require('pairs/favsServPair');

			PanelMenuMarkup = require('text!templates/panelmenu.html');
      require('css3animate');


	var router = Backbone.Router.extend({


		initialize: function(){
            JSON.originalParse = JSON.parse;
            JSON.parse = function (text) {
    			if (text) {
    	        	if(text instanceof Object){
    	    			return text;
    	    		}else{
    	    			return JSON.originalParse(text);
    	    		}

    	        } else {
    	            // no longer crashing on null value but just returning null
    	            return null;
    	        }
            }

            window.App = {
                favs : new FavsPair.Collection(),
                favsServs : new FavsServPair.Collection(),
                services : new BasicPair.Collection()
            };

            /*overrides androids hardware back button*/
            // document.addEventListener("backbutton", function(){return false;}, false);

            window.mapView = false;
            window.router = this;
            var screenSize = window.innerHeight;
            screenSize = screenSize-44;


            $('#content').height(screenSize+'px');

            $.ui.showBackbutton = false;
            $.ui.removeFooterMenu();
            $.ui.slideSideMenu = true;
            $.ui.setSideMenuWidth($("#afui").width()-80);
            $.ui.lockPageBounce = false;
            $.ui.loadingText = 'Cargando contenido';


            /*Starting fastclick*/
            FastClick.attach(document.body);
            /*Backbone history*/
            Backbone.history.start();



            /*Event bind for AppFramework load event*/
            $(document).on("loadpanel",".panel",function(event){
            	var self = this;
                setTimeout(function(){
                    window.router.saveMap(self)
                },500);

            });



            $(document).on("unloadpanel",".panel",function(event){

            	var id = $(this).attr('id');
            	setTimeout(function(){
            		$('#'+id).remove();
            		if(id == "afui_ajax"){
            			// navigator.splashscreen.hide();
            			$('#whiteMask').addClass('hide');
            		}
            	},400);
            	//check if the unloaded page has the map to change global flag window.mapview
            	if($(this).hasClass('dealPage') === true || $(this).attr('id') === 'tutorial'){
            		window.mapView = false;
            	}
            });

			/*event listener for the white mask fade animation*/
			var whiteMask = document.getElementById('whiteMask');
			whiteMask.addEventListener('webkitAnimationEnd',function( event ) {
				whiteMask.style.display = 'none';
			}, false);


			/*creting the panel links markup*/
			var panelMenu =  Handlebars.compile(PanelMenuMarkup);
			$.getJSON(Config.server+'categories',
				null,
				function(data){
					$('#leftPanel').append(panelMenu({menu:data}));
				}
			);
			/*search field btn listeners*/
			$(document).on('tap', '#mainHeader .searchBtn', function(e){

				$('#mainHeader .search').toggleClass('open');
				if($('#mainHeader .search').hasClass('open')){
					$('#mainHeader .search .term').focus()
				}

				if($('#mainHeader .lower').hasClass('open')){
					$('#mainHeader .lower').removeClass('open');

				}
			});
			$(document).on('tap', '#mainHeader .search .clear', function(e){
				$('#searchForm .term').val('');
			});

			$(document).on('submit', '#searchForm', function(e){
				e.preventDefault();
				var rand = Math.floor((Math.random()*100)+1);
				window.location.hash = '#search/'+rand;
			});

			/*left panel button listeners*/
			$(document).on('tap', '#mainHeader .panelBtn', function(e){

				$.ui.toggleSideMenu();
			});
			/*$(document).on('swipeRight', function(e){
				if(window.mapView === true) return;
				$.ui.toggleSideMenu(true);
			});
			$(document).on('swipeLeft', function(e){
				if(window.mapView === true) return;
				$.ui.toggleSideMenu(false);
			});*/

			/*top panel listener*/
			$(document).on('swipeDown tap', '#mainHeader .logo', function(e){
				if(e.type == "tap" && $('#mainHeader .lower').hasClass("open")){
					$('#mainHeader .lower').removeClass('open');
				}
				else{
					$('#mainHeader .lower').addClass('open');
				}
			});
			$(document).on('swipeUp tap', '#mainHeader .lower', function(e){
				if(e.type == "tap" && !$('#mainHeader .lower').hasClass("open")){
					$('#mainHeader .lower').addClass('open');
				}else{
					$('#mainHeader .lower').removeClass('open');
				}
			});
			$(document).on('tap', '.shareAppFbBtn', function(){
				// var title =  encodeURIComponent('Aplicación Convenios Colsubsidio');
				// var text = encodeURIComponent('Descarga la aplicación de convenios Colsubsido. Con todo lo que te mereces.');
				// var url = encodeURIComponent('http://bit.ly/1g6V1ag');
				// var image =  encodeURIComponent('http://imaginamosds.com/JPS/colsubsidio/colsubsidio.png');
				// var urlFacebook = 'http://www.facebook.com/sharer.php?m2w&s=100&p[url]='+url+'&p[title]='+title+'&p[summary]='+text+'&p[images][0]='+image;
				var link = encodeURIComponent('http://bit.ly/1g6V1ag');
				var urlFacebook = 'https://www.facebook.com/sharer/sharer.php?u='+link;

				var ref = window.open(urlFacebook, '_blank', 'location=yes');
				ref.addEventListener('exit', function(event) { ref.close(); } );
			});
			$(document).on('tap', '.shareAppTwBtn', function(){
				var texto = encodeURIComponent('Descarga la aplicación de convenios Colsubsido. Con todo lo que te mereces. iPhone http://bit.ly/16gJboA y Android http://bit.ly/1g6V1ag');
				var urlTwitter = 'http://twitter.com/intent/tweet?text='+texto;
				var ref = window.open(urlTwitter, '_blank', 'location=yes');
				ref.addEventListener('exit', function(event) { ref.close(); } );
			});

			/*cards button listeners*/
			$(document).on('tap', '#pestanaBox .btn', function(e){
				$('#pestanaBox').toggleClass('open');
			});


			/*Listener for small cards*/
			$(document).on('tap', '.cardSmall .imgFrame, .cardSmall .elems', function(e){
				var href = $(e.currentTarget).parent('.cardSmall').find('.imgFrame a').attr('href');
				window.location.hash = href;

			});

            Util.initMap();
			window.plugins.pushNotification.register(successHandler, errorHandler, {"senderID":"1085164755146", "ecb":"onNotificationGCM"});// result contains any message sent from the plugin call
			function successHandler (result) {
                console.log('result = '+result);
			}
			function errorHandler (error) {
                alert(error);
				//console.log('error = '+error);
			}



			window.onNotificationGCM = function(e) {
            // $("#app-status-ul").append('<li>EVENT -> RECEIVED:' + e.event + '</li>');
                
                switch( e.event )
                {
                    case 'registered':
                    if ( e.regid.length > 0 )
                    {
                        var deviceUUID = e.regid;
                        
    										/*Enviar uuid*/
    										$.ajax({
    											url:Config.server+'devices',
    											data:{
    												uuid: deviceUUID,
    												android: 'yes'
    											},
    											type:'POST',
    											success: function(){
    												//console.log('deviced saved');
    											}
    										});
                    }
                    break;

                    case 'message':
                        /*if (e.foreground)
                        {
                        	if(!my_media){
                            	//var my_media = new Media("/android_asset/www/"+e.soundname);
                            	//my_media.play();
                           	}
                        }
                        else
                        {   // otherwise we were launched because the user touched a notification in the notification tray.
                            if (e.coldstart){
    													//console.log('--COLDSTART NOTIFICATION--');

    												} else{
    													//console.log('--BACKGROUND NOTIFICATION--');

    												}
                        }
                        //console.log("set hash to pushlist");*/
                        //window.location.hash = "pushList";
                        // $("#app-status-ul").append('<li>MESSAGE -> MSG: ' + e.payload.message + '</li>');
                        // $("#app-status-ul").append('<li>MESSAGE -> MSGCNT: ' + e.payload.msgcnt + '</li>');
                    break;

                    case 'error':
    					//				console.log(e.msg);
                        // $("#app-status-ul").append('<li>ERROR -> MSG:' + e.msg + '</li>');
                    break;

                    default:
    					//				console.log('EVENT -> Unknown, an event was received and we do not know what it is');
                        // $("#app-status-ul").append('<li>EVENT -> Unknown, an event was received and we do not know what it is</li>');
                    break;
                }
            };
	   },

		routes:{
			"" : "tutorial",
			"home" : "home",
			"recent" : "recent",
			"category/:id" : "category",
			"favorites" : "favorites",
			"deal/:id" : "deal",
			"search/:rand" : "search",
			"services" : "services",
			"services/:catId" : "servicesGroup",
			"service/:catId/:itemId" : "serviceDetail",
			"contact":"contact",
			"pushList":"pushList",
			"how": "how"
		},

		resetApp: function(cleanPreviewApp){
				$('#pestanaBox').removeClass('open');
          		$('#mainHeader .lower').removeClass('open');
          		$('#mainHeader .search').removeClass('open');
          		$.ui.toggleSideMenu(false);

                if($(window.currentPage).length>0){
                    var mapcontent = $($(window.currentPage)[0].elmId).find("#mapcontent")
                    console.log("saving map",mapcontent.length)
                    if(mapcontent.length>0){
                        Util.clearMapStore();
                        Util.clearDirections();
                        if(mapcontent.find("#map").length>0){
                            jQuery("#map").detach().appendTo('#content');
                        }
                    }
                }
          		if(cleanPreviewApp){
          			if(jQuery){
          				jQuery("#tutorial").remove()
          			}else{
          				$(window.currentPage).remove()
          			}

          		}
		},
		tutorial : function(){
            window.useMap = false
			$.ui.showMask();
			setTimeout(function(){
				var hasSeenTut = localStorage.getItem("hasSeenTut");
				if(!hasSeenTut){
					var view = new TutorialView();
					localStorage.setItem("hasSeenTut", 'yes');
					window.currentPage = view;
				}else{
					window.location.hash = '#home';
				}
			},400);
		},
		home : function(){
            window.useMap = false
			this.resetApp(true);
			$.ui.showMask();
			var view = new HomeView();
			window.currentPage = view;
		},
		recent: function(){
			/*this.resetApp();
			$.ui.showMask();
			var view = new RecentView();
			window.currentPage = view;*/
			$('#pestanaBox').removeClass('open');
          	$('#mainHeader .lower').removeClass('open');
          	$('#mainHeader .search').removeClass('open');
          	$.ui.toggleSideMenu(true);
		},
		services: function(){
            window.useMap = false
			this.resetApp();
			$.ui.showMask();
			var view = new ServicesView();
			window.currentPage = view;
		},
		servicesGroup: function(catId){
            window.useMap = true
			this.resetApp();
			$.ui.showMask();
			var view = new ServicesGroupView({catId:catId});
			window.currentPage = view;
		},
		serviceDetail: function(catId, itemId){
            window.useMap = true
			this.resetApp();
			$.ui.showMask();
			var view = new ServiceDetailView({catId:catId, itemId:itemId});
			window.currentPage = view;
		},
		category: function(id){
            window.useMap = true
			this.resetApp();
			$.ui.showMask();
			if(window.currentPage!="" && window.currentPage!=undefined){
				try{
					window.currentPage.destroyView(window.currentPage);
				}catch(e){
					//console.log("cant to remove",e);
				}

			}

			var view = new CategoryView({catId:id});
			window.currentPage = view;
		},

		favorites: function(){
            window.useMap = false
			this.resetApp();
			$.ui.showMask();
			var view = new FavoritesView();
			window.currentPage = view;
		},
		deal: function(id){
            window.useMap = true
			this.resetApp();
			$.ui.showMask();
			var view = new DeailView({itemId:id});
			window.currentPage = view;
		},
		search : function(rand){
            window.useMap = false
			this.resetApp();
			$.ui.showMask();
			var view = new SearchView({rand:rand});
			window.currentPage = view;
		},
		contact: function(){
            window.useMap = false
			this.resetApp();
			$.ui.showMask();
			var view = new ContactView();
			window.currentPage = view;
		},
        saveMap:function(self){
            console.log("save map");
            if($(self).find("#mapcontent").length>0){
                        jQuery("#map").detach().appendTo('#mapcontent');
                }else if(window.useMap){
                    self.waitForMap = setInterval(function(){
                        if($(self).find("#mapcontent").length>0){
                            jQuery("#map").detach().appendTo('#mapcontent');
                            clearInterval(self.waitForMap)
                        }
                    },700)
                }
        },
		pushList: function(){
            window.useMap = false
			this.resetApp();
			$.ui.showMask();
			var view = new PushListView();
			window.currentPage = view;
		},
		how: function(){
            window.useMap = false
			this.resetApp();
			$.ui.showMask();
			var view = new HowView();
			window.currentPage = view;
		}

	});
	return router;
});
