/*
|-----------------------------------------------------------------------------
| Basic VIEW
|-----------------------------------------------------------------------------
*/
define(function (require) {
	/*Define require deps*/
  var $ = require('af'),
      ui = require('ui'),
      Backbone = require('backbone'),
      Handlebars = require('handlebars'),
			Config = require('config'),
			Util = require('util'),
      mainMarkup = require('text!templates/contact.html');




	var theView = Backbone.View.extend({

		template: Handlebars.compile(mainMarkup),
		events: {
			'submit #contactForm': 'validateForm',
			'tap .termsOfUser':'showTermsOfUser',
			'tap .closeBtn':'closeModal'
		},
		initialize: function(){
			this.render();
		},

		render: function(){
			$.feat.nativeTouchScroll=true;

			var self = this;
			self.elmId = '#contact';
			$.ui.addContentDiv(self.elmId, this.template());
			$.ui.loadDiv(self.elmId,false,false,'slide');
			this.setElement($(self.elmId));
			$('#mainHeader .lower').removeClass('open');
			$.ui.toggleNavMenu('false');
			$.ui.hideMask();
			$('#contactForm .fullName').focus().trigger(e);
		},
		showTermsOfUser:function(e){
			e.preventDefault();
			$("#modalTerms").show();
		},
		closeModal:function(e){
			e.preventDefault();
			$("#modalTerms").hide();
		},
		validateForm:function(e){
			e.preventDefault();
			var self = $("#contactForm");
			data = self.serialize();
			$.ajax({
				url: Config.server+'comment',
				data: data,
				type: 'POST',
				dataType:'json',
				success: function(data){
                    
					if(data.status=="success"){
						window.location.hash = '#home';
					}else{
						Util.noConnectionMessage();
					}
				},
				error: function(err){
					Util.noConnectionMessage();
				}
			});
		}

	});


	return theView;


});
