/*
|-----------------------------------------------------------------------------
| Basic VIEW
|-----------------------------------------------------------------------------
*/
define(function (require) {
	/*Define require deps*/
	var $ = require('af'),
	ui = require('ui'),
	Backbone = require('backbone'),
	Handlebars = require('handlebars'),
	Config = require('config'),
	Util = require('util'),
	BasicPair = require('pairs/basicPair'),
	mainMarkup = require('text!templates/deal.html');
  // require('async!http://maps.google.com/maps/api/js?sensor=true!callback');



	var theView = Backbone.View.extend({

		template: Handlebars.compile(mainMarkup),
		events: {
			'tap .closeBtn': 'closeCard',
			'tap .openBtn': 'openCard',
			'tap .favBtn': 'addTofavs',
			'tap .faceBtn': 'shareFacebook'
		},

		allMarkers:[],


		initialize: function(options){
			this.options = options;
			this.render();
		},

		render: function(){
			window.mapView = true; //change global value for the sidebar not to move

			var self = this;
			self.elmId = '#deal'+this.options.itemId;
			$.ui.addContentDiv(self.elmId, '<span class="loadingInPanel">.....</span>');
			$.ui.loadDiv(self.elmId,false,false,'slide');
			$(self.elmId).addClass('dealPage');
			self.setElement($(self.elmId));
			$.ui.toggleNavMenu('false');
			self.fetchData();
		},
		addTofavs: function(e){
			e.preventDefault();
			$(e.currentTarget).addClass("active");
			var self = this;
			Util.saveToFavs(self.deal);
		},
		shareFacebook: function(e){
			e.preventDefault();
			var self = this;
			Util.shareItem(self.deal);
		},
		fetchData: function(){
			var self =  this;
			$.ajax({
				url: Config.server+'agreement/'+this.options.itemId,
				type:'GET',
				success: function(data){
					$.ui.hideMask();
					self.deal = new BasicPair.Model(JSON.parse(data));
					self.deal.attributes.fav = ""
					if(App.favs.get(self.deal.id)){
						self.deal.attributes.fav = "active"
					}
					$(self.elmId).html(self.template({deal:self.deal.toJSON()}));
					Util.putStoresMarkers([self.deal.toJSON().branches]);

				},
				error: function(){
					Util.noConnectionMessage();
				}
			});
		},
		closeCard: function(e){
			$('.infoBox').addClass('close');
			$('.openBtn').addClass('open');
		},
		openCard: function(e){
			$('.infoBox').removeClass('close');
			$('.openBtn').removeClass('open');
		},
		destroyView: function(view) {

			// COMPLETELY UNBIND THE VIEW

			view.undelegateEvents();

			//view.el.removeData().unbind();

			// Remove view from DOM
			view.remove();
			Backbone.View.prototype.remove.call(view);

		}


	});


return theView;


});
