/*
|-----------------------------------------------------------------------------
| Basic VIEW
|-----------------------------------------------------------------------------
*/
define(function (require) {
	/*Define require deps*/
	var $ = require('af'),
	ui = require('ui'),
	Backbone = require('backbone'),
	Handlebars = require('handlebars'),
	Util = require('util'),
	mainMarkup = require('text!templates/favorites.html');



	var theView = Backbone.View.extend({

		template: Handlebars.compile(mainMarkup),
		events: {
			'tap .cardSmall .delete .btn': 'openConfirmDialog',
			'tap .deals .delete': 'deleteDeal',
			'tap .services .delete': 'deleteService',
			'tap .faceBtnItem': 'shareItem',
			'tap .faceBtnServ': 'shareServ'
		},

		initialize: function(){
			this.render();
		},

		render: function(){
			$.ui.hideMask();
			var self = this;
			var deals = self.getFavDeals();
			var services = self.getFavServices();
			var elmId = '#favorites';
			$.ui.addContentDiv(elmId, self.template({deals:deals, services:services}));
			$.ui.loadDiv(elmId,false,false,'slide');
			self.setElement($(elmId));
			$.ui.toggleNavMenu('false');
		},
		getFavDeals :  function(){
				var deals = JSON.parse(localStorage.getItem("favs"));
				return deals;
		},
		getFavServices :  function(){
				var services = JSON.parse(localStorage.getItem("favsServ"));
				return services;
		},
		openConfirmDialog:function(e){
			$(e.currentTarget).toggleClass('open');
			$(e.currentTarget).parents('.cardSmall').find('.deleteConfirm').toggleClass('open');
		},
		deleteDeal: function(e){
			var self = this;
			var itemId = $(e.currentTarget).attr('data-id');
			App.favs.remove(App.favs.get(itemId).cid);
			$(e.currentTarget).parent('.cardSmall').remove();
			var deals = self.getFavDeals();
			var services = self.getFavServices();
			if(deals && deals.length <= 0){
				$('.cardHolder.deals').append('<h3>No tienes ningún <strong>convenio</strong> guardado en tus favoritos.</h3>');
			}
		},
		deleteService: function(e){
			var self = this;
			var itemId = $(e.currentTarget).attr('data-id');
			App.favsServs.remove(App.favsServs.get(itemId).cid);
			$(e.currentTarget).parent('.cardSmall').remove();
			var services = self.getFavServices();
			if(services && services.length <= 0){
				$('.cardHolder.services').append('<h3>No tienes ningún <strong>servicios</strong> guardado en tus favoritos.</h3>');
			}
		},
		shareItem: function(e){
			e.preventDefault();
			var self = this;
			var dealId = $(e.currentTarget).attr('data-id');
			var deal = App.favs.get(dealId);
			Util.shareItem(deal);
		},
		shareServ: function(e){
			e.preventDefault();
			var self = this;
			var servId = $(e.currentTarget).attr('data-id');
			var serv = App.favsServs.get(servId);
			Util.shareService(serv.toJSON());
		}

	});


return theView;


});
