/*
|-----------------------------------------------------------------------------
| Basic VIEW
|-----------------------------------------------------------------------------
*/
define(function (require) {
	/*Define require deps*/
	var $ = require('af'),
		ui = require('ui'),
		Backbone = require('backbone'),
		Handlebars = require('handlebars'),
		Config = require('config'),
		Util = require('util'),
		BasicPair  = require('pairs/basicPair'),
		mainMarkup = require('text!templates/pushList.html');
      
	var theView = Backbone.View.extend({

		template: Handlebars.compile(mainMarkup),
		events: {
		},
		initialize: function(){
			this.fetchData();
		},
		fetchData:function(){
			var self = this;
			$.ajax({
				url: Config.server+'notifications',
				type:'GET',
				success: function(data){
					$.ui.hideMask();
					self.render(data);
				},
				error: function(){
					//TODO: error message;
					Util.noConnectionMessage();
				}
			});
		},
		render: function(data){
			$.feat.nativeTouchScroll=false;
			var self = this;
			var jsonData = JSON.parse(data);

			self.dataList = new BasicPair.Collection(jsonData);
			self.elmId = '#pushlist';
			self.compiledTemplate = self.template({
						dataList:self.dataList.toJSON()
						});

			$.ui.addContentDiv(self.elmId, self.compiledTemplate);
			$.ui.loadDiv(self.elmId,false,false,'slide');
			this.setElement($(self.elmId));
			$('#mainHeader .lower').removeClass('open');
			$.ui.toggleNavMenu('false');
			$.ui.hideMask();
		}
		

	});


	return theView;


});