/*
|-----------------------------------------------------------------------------
| Basic VIEW
|-----------------------------------------------------------------------------
*/
define(function (require) {
	/*Define require deps*/
  var $ = require('af'),
      ui = require('ui'),
						Config = require('config'),
      Backbone = require('backbone'),
      Handlebars = require('handlebars'),
      Util =  require('util'),
      mainMarkup = require('text!templates/recent.html'),
      Deals = require('pairs/deal');


	var theView = Backbone.View.extend({

		template: Handlebars.compile(mainMarkup),
		events:{
			'tap .favBtn': 'addTofavs',
			'tap .faceBtn': 'shareFacebook'
		},

		initialize: function(){
			this.render();
			$('#mainHeader .lower').removeClass('open');
		},

		render: function(){
			var self = this;
			self.elmId = '#recent';
			/*Aparently the scroll in Android only works when addContentDiv has full html*/
			// $.ui.addContentDiv(self.elmId, '<span class="loadingInPanel">.....</span>');
			// $.ui.loadDiv(self.elmId,false,false,'slide');
			// this.setElement($(self.elmId));
			$.ui.toggleNavMenu('false');
			self.fetchData();

		},
		addTofavs : function(e){
			e.preventDefault();
			var self = this;
			var dealId = $(e.currentTarget).attr('data-id');
			Util.saveToFavs(self.deals.get(dealId));
			// console.log(self.deals.get(dealId).toJSON());
		},
		shareFacebook: function(e){
			e.preventDefault();
			var self = this;
			var dealId = $(e.currentTarget).attr('data-id');
			var deal = self.deals.get(dealId);
			Util.shareItem(deal);
		},
		fetchData : function(){
			var self = this;
			self.deals = new Deals.Collection();
			self.deals.fetch({
				url: Config.server+'categories/recent',
				success:function(){
					self.makeView();
				}
			});
		},
		makeView:function(){
			$.ui.hideMask();
			var self = this;
			var html = this.template({deals: self.deals.toJSON()});
			$.ui.addContentDiv(self.elmId, html);
			$.ui.loadDiv(self.elmId,false,false,'slide');
			this.setElement($(self.elmId));
			$.ui.toggleNavMenu('false');
			// $(self.elmId).html(html);
		}

	});


	return theView;


});