/*
|-----------------------------------------------------------------------------
| Basic VIEW
|-----------------------------------------------------------------------------
*/
define(function (require) {
	/*Define require deps*/
	var $ = require('af'),
	ui = require('ui'),
	Config = require('config'),
	Backbone = require('backbone'),
	Handlebars = require('handlebars'),
	Util = require('util'),
	BasicPair  = require('pairs/basicPair'),
	mainMarkup = require('text!templates/services.html');



	var theView = Backbone.View.extend({

		template: Handlebars.compile(mainMarkup),

		initialize: function(options){
			this.options = options;
			$('#mainHeader .lower').removeClass('open');
			this.render();
		},

		render: function(){
			var self = this;
			_.bindAll(this, 'cleanup');

			self.elmId = '#services';
			/*Aparently the scroll in Android only works when addContentDiv has full html*/
			// $.ui.addContentDiv(self.elmId, '<span class="loadingInPanel">.....</span>');
			// $.ui.loadDiv(self.elmId,false,false,'slide');
			// self.setElement($(self.elmId));
			// $.ui.toggleNavMenu('false');

			self.fetchData();

		},
		fetchData:function(){
			var self = this;
            self.setAutoCarouselStocks();
			$.ajax({
				url: Config.server+'services',
				type:'GET',
				success: function(data){
                    stringJsonServices = data;
					$.ui.hideMask();
					self.parseData(data);
				},
				error: function(){
					Util.noConnectionMessage();
				}
			});
		},
        setAutoCarouselStocks:function(){
			var self = this;
			if($("#home").length>0){
				var nextStep =0;
				if(carouselStocks.carouselIndex+1 < carouselStocks.childrenCount){
					nextStep = carouselStocks.carouselIndex+1;
				}
                carouselStocks.onMoveIndex(nextStep,1000);
			}else{
				//clearInterval(window.carouselIntervalStocks);
			}
		},
		parseData:function(data){
			var self = this;
			var jsonData = JSON.parse(data);

			App.services.reset(jsonData); // puting it in the global

			self.subcategories = new BasicPair.Collection(jsonData);
			self.compiledTemplate = self.template({subcategories:self.subcategories.toJSON()});

			/*grouping all deals in one collection*/
			self.deals = new BasicPair.Collection();
			for (var i = 0; i < self.subcategories.length; i++) {
				self.deals.add(self.subcategories.toJSON()[i].providers);
			}
			self.initialSetup();
		},
		initialSetup : function(){
			var self = this;
			$.ui.addContentDiv(self.elmId, self.compiledTemplate);
			$.ui.loadDiv(self.elmId,false,false,'slide');
			self.setElement($(self.elmId));
			$.ui.toggleNavMenu('false');

		},
		cleanup: function() {
			this.undelegateEvents();
			$(this.el).empty();
		}

	});


return theView;


});
