/*
|-----------------------------------------------------------------------------
| Basic VIEW
|-----------------------------------------------------------------------------
*/
define(function (require) {
	/*Define require deps*/
  var $ = require('af'),
      ui = require('ui'),
      Backbone = require('backbone'),
      Handlebars = require('handlebars'),
			Config = require('config'),
			Util = require('util'),
      mainMarkup = require('text!templates/tutorial.html');
      require('carousel');



	var theView = Backbone.View.extend({

		template: Handlebars.compile(mainMarkup),
		initialize: function(){
			this.render();
		},

		render: function(){
			var self = this;
			window.mapView = true;
			self.elmId = '#tutorial';
			$.ui.addContentDiv(self.elmId, this.template());
			$.ui.loadDiv(self.elmId,false,false,'slide');
			this.setElement($(self.elmId));
			$.ui.toggleNavMenu('false');
			$.ui.hideMask(false);
			$('#mainHeader .lower').removeClass('open');

			var carousel;
			function init_carousel() {
				carousel = $("#carousel").carousel({
					pagingDiv: "carousel_dots",
					pagingCssName: "dot",
					pagingCssNameSelected: "dot_selected",
					preventDefaults:false
				});
			}
			init_carousel();

		}

	});


	return theView;


});